#!/usr/bin/perl -I/usr/sausalito/perl -I/usr/sausalito/handlers/base/power
# $Id: wakemode.pl

use CCE;
use Sauce::Util;
use I18n;

my ($return1, $return2);
my $flag = 0;
my $port;
my $kernel_wakeutil = '/usr/sbin/ethtool';
my $eeprom_wakeutil = '/usr/sbin/enet_eeprom';
my $cce = new CCE("Namespace" => "Power");
$cce->connectfd();

my $old = $cce->event_old();
my $object = $cce->event_object();
my $new = $cce->event_new();

if (-e $kernel_wakeutil && -e $eeprom_wakeutil ) {
	# find out what IO port the ethernet controller uses.
	open PCI, '</proc/pci';
	while (<PCI>) {
		if (/Ethernet/) {
		$flag = 1;
		} elsif ($flag && /I\/O/) {
		/at (\w+)/;
		$port = $1;
		last;
		}
	}
	close(PCI);

	my @eeprom_args = ($eeprom_wakeutil, '-p', $port, '-d', 'natsemi', '-w', 'wol');
	my @kernel_args = ($kernel_wakeutil, '-s', 'eth0', 'wol');

	if ($new->{wakemode} || $new->{set_modes_now}) {
		if ($object->{wakemode} eq 'none') {
		push @kernel_args, ('d');
		push @eeprom_args, ('d');
		} elsif ($object->{wakemode} eq 'magic') {
		push @kernel_args, ('g');
		push @eeprom_args, ('g');
		}
    
		$return1 = system(@kernel_args);
		$return2 = system(@eeprom_args);

		if (($return1 != 0) || ($return2 != 0)) {
		$cce->warn("[[base-power.errSettingWakeMode]]");
		$cce->bye('FAIL');
		exit 1;
		}
	}
}

$cce->bye('SUCCESS');
exit 0;

# 
# Copyright (c) 2008-2020 Michael Stauber, SOLARSPEED.NET
# Copyright (c) 2008-2020 Team BlueOnyx, BLUEONYX.IT
# All Rights Reserved.
# 
# 1. Redistributions of source code must retain the above copyright 
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright 
#    notice, this list of conditions and the following disclaimer in 
#    the documentation and/or other materials provided with the 
#    distribution.
# 
# 3. Neither the name of the copyright holder nor the names of its 
#    contributors may be used to endorse or promote products derived 
#    from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
# 
# You acknowledge that this software is not designed or intended for 
# use in the design, construction, operation or maintenance of any 
# nuclear facility.
#